/**
 * @file 基础js，包含对原生对象的扩展和evm.js的扩展
 * @createTime:2015-10-28
 */
/**************************************************************************************
 *                                 对原生对象的扩展
/**************************************************************************************/
// 日期格式化
// @F: 日期时间格式
Date.prototype.format = function( F )
{
    F = F || 'YYYY-mm-dd HH:ii:ss';
    var o =
    {
        'm+' :  this.getMonth() + 1	//月
        ,'d+' : this.getDate()		//日
        ,'H+' : this.getHours()		//时
        ,'i+' : this.getMinutes()	//分
        ,'s+' : this.getSeconds()	//秒
        ,'q+' : Math.floor((this.getMonth() + 3) / 3)	//季
        ,'S+' : this.getMilliseconds()	//毫秒
        ,'w+' : ['0', '1', '2', '3', '4', '5', '6'][this.getDay()]
        ,'W+' : ['日', '一', '二', '三', '四', '五', '六'][this.getDay()]
    }

    if( /(Y+)/.test( F )) F = F.replace( RegExp.$1, ( this.getFullYear() + '' ).substr( 4 - RegExp.$1.length ));
    for( var K in o )
    {
        if( new RegExp( '(' + K + ')' ).test( F ))
            F = F.replace( RegExp.$1
                ,( RegExp.$1.length == 1 ) ? ( o[K] ) : ( (( K == 'S+' ? '000' : '00' ) + o[K]).substr(('' + o[K]).length)) );
    }
    return F;
};

(function(window,undefined){
    //处理Json
    var JSON = {
        parse:function(val){
            if(typeof val === 'string'){
                val = eval('('+val+')');
            }
            return val;
        }
    };
    window.JSON = JSON;

    var evm = window.evm || {};
    evm.extend(evm,{
        $:function(val){
            if(typeof val === 'string'){
                val = document.getElementById(val);
            }
            return val;
        },
        addEvent:function(elm,type,fn){
            if(!(elm = evm.$(elm))) return;

            if(elm.addEventListener){
                elm.addEventListener(type,fn,false);
            }
            else if(elm.attachEvent){
                elm['e'+type+fn] = fn;
                elm[type+fn] = function(){
                    elm['e'+type+fn](window.event);
                }
                elm.attachEvent('on'+type,elm[type+fn]);
            }
        },
        getElementsByClassName:function(className,tag,parent){
            parent = parent || document;
            if(!(parent = evm.$(parent))) return false;

            var allTags = parent.all && tag === '*' ? parent.all : parent.getElementsByTagName(tag);

            className = className.replace(/\-/g,/\\-/);
            var reg = new RegExp('(^|\\s+)'+ className +'(\\s+|$)');
            var matchingElements = [];
            for(var i = 0;i < allTags.length;i++){
                var node = allTags[i];
                if(reg.test(node.className)){
                    matchingElements.push(node);
                }
            }
            return matchingElements;
        },
        trim:function(str){
            return str.replace(/^\s+|\s+$/g,'');
        },
        cookie:function (name, value, options) {
            if (typeof value != 'undefined') { // name and value given, set cookie
                options = options || {};
                if (value === null) {
                    value = '';
                    options.expires = -1;
                }
                var expires = '';
                if (options.expires && (typeof options.expires == 'number' || options.expires.toUTCString)) {
                    var date;
                    if (typeof options.expires == 'number') {
                        date = new Date();
                        date.setTime(date.getTime() + (options.expires * 24 * 60 * 60 * 1000));
                    } else {
                        date = options.expires;
                    }
                    expires = '; expires=' + date.toUTCString(); // use expires attribute, max-age is not supported by IE
                }
                var path = options.path ? '; path=' + options.path : '';
                var domain = options.domain ? '; domain=' + options.domain : '';
                var secure = options.secure ? '; secure' : '';
                document.cookie = [name, '=', encodeURIComponent(value), expires, path, domain, secure].join('');
            } else { // only name given, get cookie
                var cookieValue = null;
                if (document.cookie && document.cookie != '') {
                    var cookies = document.cookie.split(';');
                    for (var i = 0; i < cookies.length; i++) {
                        var cookie = evm.trim(cookies[i]);
                        // Does this cookie string begin with the name we want?
                        if (cookie.substring(0, name.length + 1) == (name + '=')) {
                            cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                            break;
                        }
                    }
                }
                return cookieValue;
            }
        }
    });
})(this);
