﻿/*
 * 键盘
 * create by yangty@evmtv.com on 4 Jane, 2015
 */

evm.ext.comp.Keyboard = function (_c/*config object*/) {
    // 强制使用new
    if(this === evm.ext.comp || this === window) {
        return new arguments.callee(_c);
    }
  
    // 必须传参
    if(evm.isUndefined(_c) && !(evm.isObject(_c))) {
        throw Error('not found config parameter');
    }
  
    function hander(_c/*event object*/){
        // 触发事件的默认方法
        try{
            //console.log('Keyboard 事件触发,默认处理方法');
        }catch(E){};
    }

    evm.ext.comp.BaseComponent.call(this, _c/*object*/);
    this.config         = _c;
    this.box_elem        = null; // 容器
    this.box_id         = _c.boxID || this.comp_name; // 容器ID
    this.parent_node    = _c.parentNode || null; // 父容器
    this.animate_switch = evm.isBoolean(_c.animate) ?
                        _c.animate : true; // 是否开启动画
    this.items          = _c.keys || evm.ext.comp.Keyboard.keys; // 键盘集合
    this.capital_switch = evm.isBoolean(_c.capital) ?
                        _c.capital : false;
    this.active_index   = 0;
    this.back_index     = -1;
    this.col            = _c.col || 14;
    this.row            = _c.row || 5;
    this.cell_width     = _c.cellWidth || 34;
    this.cell_height    = _c.cellHeight || 34;
    this.start_x        = _c.startX || 0;
    this.start_y        = _c.startY || 0;
    this.gap_x          = _c.gapX || 5;
    this.gap_y          = _c.gapY || 5;
    this.key_name       = this.box_id + "_char_";
    this.dir            = _c.dir || '/swatapps/ape/source/img/keyboard/w_';
    //====自定义事件的回调方法,在创建对象时传入对应的回调方法;==========================
    this.onBlur = _c.onBlur || hander;
    this.onChange = _c.onChange || hander;
    this.onChangeOut = _c.onChangeOut || hander;
    this.onFocus = _c.onFocus || hander;
    this.onSelect = _c.onSelect || hander;
    this.onEvent = _c.onEvent || hander;
}

evm.ext.comp.Keyboard.keys = [
    {val:"{", icon:"{"},{val:"}",icon:"}"},{val:"(", icon:"("}
    , {val:")", icon:")"}, {val:"[", icon:"["}, {val:"]", icon:"]"}
    , {val:"<", icon:"lt"}, {val:">", icon:"gt"}, {val:"%", icon:"per"}
    , {val:"~", icon:"~"}, {val:"+", icon:"plus"}, {val:"-", icon:"minus"}
    , {val:"*", icon:"*"}, {val:"/", icon:"slash"}
    
    , {val:"a", icon:"a"}, {val:"b", icon:"b"}, {val:"c", icon:"c"}
    , {val:"d", icon:"d"}, {val:"e", icon:"e"}, {val:"f", icon:"f"}
    , {val:"g", icon:"g"}, {val:"h", icon:"h"}, {val:"i", icon:"i"}
    , {val:"j", icon:"j"}, {val:"k", icon:"k"},{val:"7", icon:"7"}
    , {val:"8", icon:"8"}, {val:"9", icon:"9"}
    
    , {val:"l", icon:"l"}, {val:"m", icon:"m"}, {val:"n", icon:"n"}
    , {val:"o", icon:"o"}, {val:"p", icon:"p"}, {val:"q", icon:"q"}
    , {val:"r", icon:"r"}, {val:"s", icon:"s"}, {val:"t", icon:"t"}
    , {val:"u", icon:"u"}, {val:"v", icon:"v"},{val:"4", icon:"4"}
    , {val:"5", icon:"5"}, {val:"6", icon:"6"}
    
    , {val:"w", icon:"w"}, {val:"x", icon:"x"}, {val:"y", icon:"y"}
    , {val:"z", icon:"z"}, {val:",", icon:"dou"}, {val:"_", icon:"_"}
    , {val:":", icon:"colon"},{val:"\"", icon:"shuangyin"},{val:"\\", icon:"anti-slash"}
    , {val:"^", icon:"^"}, {val:"#", icon:"hash"}, {val:"1", icon:"1"}
    , {val:"2", icon:"2"}, {val:"3", icon:"3"}
    
    , {val:"#cap", icon:["nor","cap"]}, {val:"!", icon:"!"}, {val:"@", icon:"@"}
    , {val:"$", icon:"$"}, {val:"&", icon:"&"}, {val:"?", icon:"question"}
    , {val:";", icon:"semicolon"}, {val:"'", icon:"danyin"}, {val:"|", icon:"|"}
    , {val:"=", icon:"equal"}, {val:"#del",icon:"delete"}, {val:".", icon:"dot"}
    , {val:"0", icon:"0"}, {val:"#close", icon:"close"}
];

evm.extend(evm.ext.comp.Keyboard.prototype, {
    init: function() {
        var me = this;
        // 查找键盘容器元素
        me.box_elem = evm.$(me.box_id);
        if(evm.isString(me.parent_node)) {
            me.parent_node = evm.$(me.parent_node);
        }
        if(!me.box_elem) {
            me.box_elem = evm.createElem("div", {
                id: me.box_id
                ,className : me.class_name
                ,style : me.config.style || ""
            }, me.parent_node || document.body);
        }
        // 设置默认样式
        if(me.animate_switch) {
            evm.css(me.box_elem, {
                "-webkit-transition-duration":"200ms"
            });
        }
        me.paint().setFocus("focus");
        return me;
    }
    ,paint: function() {
        // 判断capital_switch,刷新大小写字母
        var me = this
        ,tplHTML = []
        ,clip = ''
        ,path = ''
        ,x = 0
        ,y = 0
        ,div_style = 'position:absolute;'
            +'width:' + me.cell_width + 'px;'
            +'height:'+ me.cell_height + 'px;';
    
        for(var i=0,len=me.items.length; i<len; ++i) {
            path = me.getIcon(i);
            x = me.start_x + (i % me.col)*(me.cell_width + me.gap_x*2);
            y = me.start_y + (Math.ceil((i+1)/me.col)-1)*(me.cell_height + me.gap_y*2);
      
            clip = '<div style="'
                +div_style+'left:'+ x + 'px;top:'+ y + 'px;'
                +'"><img id="'+me.key_name+i+'" src="'+ path + '"></div>';
            tplHTML.push(clip);
        }
    
        evm.html(me.box_elem, tplHTML.join(''));
        return me;
    }
    ,getIcon: function(_n/*number*/, _d/*string:'focus'or'blur'*/) {
        var me = this
        ,pat = /^[a-z]/;
   
        if(me.items[_n].val === "#cap") {
            icon = me.items[_n].icon[me.capital_switch ? 0 : 1];
        }
        else{
            icon = me.items[_n].val;
            if(pat.test(icon)) {
                icon = me.items[_n].icon + (me.capital_switch ? me.items[_n].icon:'');
            }else{
                icon = me.items[_n].icon;
            }
        }
        return me.dir+icon+(_d === "focus"?"_b":"")+".png";
    }
    ,moveTo: function(_x/*number*/, _y/*number*/) {
        // 设置键盘位置
        var me = this;
        evm.css(me.box_elem, {
            "left" : (_x + "px")
            ,"top" : (_y + "px")
        });
    }
    ,toggle: function(_d/*string:'show'or'hide'*/) {
        // 设置键盘是否可见
        var me = this, cssValue;
        if(_d === 'hide') {
            cssValue = "none";
        }
        else {
            cssValue = "block";
        }
        evm.css(me.box_elem, {display : cssValue});
    }
    ,setCapital: function(_b/*bool: 'true=capital' and 'false=normal'*/) {
        // 设置大小写
        var me = this;
        if(!evm.isBoolean(_b)) {
            return me;
        }
        me.capital_switch = _b;
        me.paint().setFocus("focus");
        return me;
    }
    ,setFocus: function(_d/*string:'focus'or'blur'*/) {
        // 切换按钮
        var me = this
        ,elem = evm.$(me.key_name+me.active_index);
        elem.src = me.getIcon(me.active_index,_d);
        return me;
    }
    ,action: function(_d/*string*/) {
        var me = this;
        _d = _d.toUpperCase();
        me.setFocus("blur");
        if(_d === "UP") {
            if(me.active_index - me.col >= 0) {
                me.active_index -= me.col;
            }
            else{
                me.active_index = (me.row-1) * me.col + me.active_index;
            }
        }
        else if(_d === "DOWN") {
            if(me.active_index + me.col <= me.items.length - 1) {
                me.active_index += me.col;
            }
            else{
                me.active_index = (me.active_index+me.col)%me.col;
            }
        }
        else if(_d === "LEFT") {
            if(me.active_index !== 0) {
                me.active_index -= 1;
            }else{
                me.active_index = me.items.length - 1;
            }
        }
        else if(_d === "RIGHT") {
            if(me.active_index !== me.items.length - 1) {
                me.active_index += 1;
            }else{
                me.active_index = 0;
            }
        }
        me.setFocus("focus");
        return me;
    }
    ,doSelect: function() {
        var me = this
        ,item = me.items[me.active_index]
        ,result = item.val;
        switch (item.val) {
            case "#cap":
                me.setCapital(!me.capital_switch); 
                break;
            case "#close":
                me.toggle("hide");
                break;
            default:
                result = item.val[me.capital_switch?"toUpperCase":"toLowerCase"]();
        }
        return result;
    }
});
