/**
 * @file evm.js的扩展
 * 依赖js文件：/swatapps/ape/evm.js
 * 创建时间:2015-01-11
 * @author wuqq@evmtv.com
 *
 * Ipanel 3.0不支持in操作符----------2015-11-24
 * 新增 盒子端日志调试类---2016-01-09
 */

/**************************************************************************************
 *                                 对原生对象的扩展
 /**************************************************************************************/
// 日期格式化
// @F: 日期时间格式
// ipanel3.0此方法运行不正确
/**
 * @deprecated
 * @param F
 * @returns {*|string}
 * @des 部分中间件会有问题，如ipanel3.0
 * 可能是中间件限制重写原生的函数或方法
 */
Date.prototype.format = function (F) {
	F = F || 'YYYY-mm-dd HH:ii:ss';
	var o =
	{
		'm+': this.getMonth() + 1	//月
		, 'd+': this.getDate()		//日
		, 'H+': this.getHours()		//时
		, 'i+': this.getMinutes()	//分
		, 's+': this.getSeconds()	//秒
		, 'q+': Math.floor((this.getMonth() + 3) / 3)	//季
		, 'S+': this.getMilliseconds()	//毫秒
		, 'w+': ['0', '1', '2', '3', '4', '5', '6'][this.getDay()]
		, 'W+': ['日', '一', '二', '三', '四', '五', '六'][this.getDay()]
	}
	if (/(Y+)/.test(F)) F = F.replace(RegExp.$1, ( this.getFullYear() + '' ).substr(4 - RegExp.$1.length));
	for (var K in o) {
		if (new RegExp('(' + K + ')').test(F))
			F = F.replace(RegExp.$1
				, ( RegExp.$1.length == 1 ) ? ( o[K] ) : ( (( K == 'S+' ? '000' : '00' ) + o[K]).substr(('' + o[K]).length)));
	}
	return F;
};
/**
 * @deprecated
 * @des 部分中间件会有问题，如ipanel3.0
 * 可能是中间件限制重写原生的函数或方法
 */
if (!Array.prototype.filter) {
	Array.prototype.filter = function (fun/*, thisArg*/) {
		if (this === void 0 || this === null) {
			throw new TypeError();
		}
		var t = Object(this);
		var len = t.length >>> 0;
		if (typeof fun !== 'function') {
			throw new TypeError();
		}
		var res = [];
		var thisArg = arguments.length >= 2 ? arguments[1] : void 0;
		for (var i = 0; i < len; i++) {
			/*if (i in t) {*/
			var val = t[i];
			// NOTE: Technically this should Object.defineProperty at
			//       the next index, as push can be affected by
			//       properties on Object.prototype and Array.prototype.
			//       But that method's new, and collisions should be
			//       rare, so use the more-compatible alternative.
			if (fun.call(thisArg, val, i, t)) {
				res.push(val);
			}
			/*}*/
		}
		return res;
	}
}
/**
 * @deprecated
 * @des 部分中间件会有问题，如ipanel3.0
 * 可能是中间件限制重写原生的函数或方法
 */
if (!Array.prototype.forEach) {
	Array.prototype.forEach = function (callback, thisArg) {
		var T, k;
		if (this == null) {
			throw new TypeError(' this is null or not defined');
		}
		// 1. Let O be the result of calling ToObject passing the |this| value as the argument.
		//var O = Object(this);//Ipanel 3.0不支持此操作
		var O = this;
		// 2. Let lenValue be the result of calling the Get internal method of O with the argument "length".
		// 3. Let len be ToUint32(lenValue).
		var len = O.length >>> 0;
		// 4. If IsCallable(callback) is false, throw a TypeError exception.
		// See: http://es5.github.com/#x9.11
		if (typeof callback !== "function") {
			throw new TypeError(callback + ' is not a function');
		}
		// 5. If thisArg was supplied, let T be thisArg; else let T be undefined.
		if (arguments.length > 1) {
			T = thisArg;
		}
		// 6. Let k be 0
		k = 0;
		// 7. Repeat, while k < len
		while (k < len) {
			var kValue;
			// a. Let Pk be ToString(k).
			//   This is implicit for LHS operands of the in operator
			// b. Let kPresent be the result of calling the HasProperty internal method of O with argument Pk.
			//   This step can be combined with c
			// c. If kPresent is true, then
			/*if (k in O) {*/
			// i. Let kValue be the result of calling the Get internal method of O with argument Pk.
			kValue = O[k];
			// ii. Call the Call internal method of callback with T as the this value and
			// argument list containing kValue, k, and O.
			callback.call(T, kValue, k, O);
			/*}*/
			// d. Increase k by 1.
			k++;
		}
		// 8. return undefined
	};
}
/**************************************************************************************
 *                                 类的帮助函数
 /**************************************************************************************/
function extend(subClass, superClass) {
	var F = function () {
	};
	F.prototype = superClass.prototype;
	subClass.prototype = new F;
	subClass.prototype.constructor = subClass;
	subClass.superClass = superClass.prototype;
	if (superClass.prototype.constructor == Object) {
		superClass.prototype.constructor = superClass;
	}
}
//原型式继承
function clone(obj) {
	var F = function () {
	};
	F.prototype = obj;
	return new F();
}
/**************************************************************************************
 *                           window.evm对象的扩展
 /**************************************************************************************/
(function (window, undefined) {
	var o2str = Object.prototype.toString;
	var evm = window.evm || {};
	evm.extend(evm, {
		//计算尺寸或者位置
		getElementPosition: function (e) {
			var x = 0, y = 0;
			while (e != null) {
				x += e.offsetLeft;
				y += e.offsetTop;
				e = e.offsetParent;
			}
			return {x: x, y: y};
		},
		getBrowserWindowSize: function () {
			var de = document.documentElement;
			return {
				'width': (window.innerWidth || (de && de.clientWidth) || document.body.clientWidth),
				'height': (window.innerHeight || (de && de.clientHeight) || document.body.clientHeight)
			};
		},
		//DOM操作
		$: function (val) {
			if (typeof val === 'string') {
				val = document.getElementById(val);
			}
			return val;
		},
		getElementsByClassName: function (className, tag, parent) {
			parent = parent || document;
			if (!(parent = evm.$(parent))) return false;
			var allTags = parent.all && tag === '*' ? parent.all : parent.getElementsByTagName(tag);
			className = className.replace(/\-/g, '\\-');
			var reg = new RegExp('(^|\\s*)' + className + '(\\s*|$)');
			var matchingElements = [];
			for (var i = 0; i < allTags.length; i++) {
				var node = allTags[i];
				if (reg.test(node.className)) {
					matchingElements.push(node);
				}
			}
			return matchingElements;
		},
		removeChildren: function (parent) {
			if (!(parent = evm.$(parent))) return false;
			while (parent.firstChild) {
				parent.removeChild(parent.firstChild);
			}
			return true;
		},
		html: function (elm, str) {
			if (str == undefined) {
				return elm.innerHTML;
			}
			elm.innerHTML = str;
		},
		show: function (elm) {
			elm.style.display = 'block';
		},
		hide: function (elm) {
			elm.style.display = 'none';
		},
		text: function (elm, str) {
			if (str == undefined) {
				return elm.innerText;
			}
			if (elm.innerText) {
				elm.innerText = str;
			}
			else {
				elm.appendChild(document.createTextNode(str));
			}
			return elm;
		},
		hasClass: function (elm, clsName) {
			return new RegExp('(^|\\s*)' + clsName + '(\\s*|$)').test(elm.className);
		},
		//事件处理
		addEvent: function (elm, type, fn) {
			if (!(elm = evm.$(elm))) return;
			if (elm.addEventListener) {
				elm.addEventListener(type, fn, false);
			}
			else if (elm.attachEvent) {
				elm['e' + type + fn] = fn;
				elm[type + fn] = function () {
					elm['e' + type + fn](window.event);
				}
				elm.attachEvent('on' + type, elm[type + fn]);
			}
			else {
				elm['on' + type] = fn;
			}
		},
		preventDefault: function (event) {
			if (event.preventDefault) {
				event.preventDefault();
			}
			else if (event.returnValue) {
				event.returnValue = false;
			}
			else {
				return false;
			}
		},
		//工具方法
		// 全局标识
		addQueryString: function (/*url,name1,name2*/) {
			var coreFunction,
				queryObj = evm.getUrl();
			coreFunction = function () {
				var url = arguments[0];
				if (!url) {
					return '';
				}
				for (var i = 1; i < arguments.length; i++) {
					var value = queryObj[arguments[i]];
					if (value) {
						value = encodeURIComponent(value);
					}
					else {
						value = '';
					}
					if (url.indexOf('?') === -1) {
						url = url + '?' + arguments[i] + '=' + value;
					} else {
						url = url + '&' + arguments[i] + '=' + value;
					}
				}
				return url;
			};
			evm.addQueryString = coreFunction;
			return coreFunction.apply(this, arguments);
		},
		__globalCounter: 0,
		// 取下一个全局唯一计数
		getNextGlobalId: function () {
			return this.__globalCounter;
		},
		// 生成指定前缀的全局唯一标识
		makeGlobalId: function (S) {
			S = S ? S : '';
			return S + ( this.__globalCounter++ ) + (Math.floor(Math.random() * 1000) + '');
		},
		isArray: function (val) {
			return o2str.call(val) === '[object Array]';
		},
		isUndefined: function (val) {
			return typeof val === 'undefined';
		},
		isNumber: function (val) {
			return typeof val === 'number';
		},
		isObject: function (val) {
			return typeof val === 'object';
		},
		isString: function (val) {
			return typeof val === 'string';
		},
		isFunction: function (val) {
			return typeof val === 'function';
		},
		trim: function (str) {
			return str.replace(/(^[\s]+)|([\s]+$)/g, '');
		},
		cookie: function (name, value, options) {
			if (typeof value != 'undefined') { // name and value given, set cookie
				options = options || {};
				if (value === null) {
					value = '';
					options.expires = -1;
				}
				var expires = '';
				if (options.expires && (typeof options.expires == 'number' || options.expires.toUTCString)) {
					var date;
					if (typeof options.expires == 'number') {
						date = new Date();
						date.setTime(date.getTime() + (options.expires * 24 * 60 * 60 * 1000));
					} else {
						date = options.expires;
					}
					expires = '; expires=' + date.toUTCString(); // use expires attribute, max-age is not supported by IE
				}
				var path = options.path ? '; path=' + options.path : '';
				var domain = options.domain ? '; domain=' + options.domain : '';
				var secure = options.secure ? '; secure' : '';
				document.cookie = [name, '=', encodeURIComponent(value), expires, path, domain, secure].join('');
			} else { // only name given, get cookie
				var cookieValue = null;
				if (document.cookie && document.cookie != '') {
					var cookies = document.cookie.split(';');
					for (var i = 0; i < cookies.length; i++) {
						var cookie = evm.trim(cookies[i]);
						// Does this cookie string begin with the name we want?
						if (cookie.substring(0, name.length + 1) == (name + '=')) {
							cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
							break;
						}
					}
				}
				return cookieValue;
			}
		},
		getQueryString: function (key) {
			var searchStr = window.location.search.substr(1);
			var reg = new RegExp(key + '=([^=&]*)');
			var value = '';
			if (reg.test(searchStr)) {
				value = window.decodeURIComponent(searchStr.match(reg)[1]);
			}
			return value;
		},
		json: {
			parse: function (val) {
				if (typeof val === 'string') {
					val = eval('(' + val + ')');
				}
				return val;
			},
			stringify: function (O) {
				// 将对象转换为 Json 串
				// Key 不使用引号, 所以不能包含空格
				//if( JSON && JSON.stringify ) return JSON.stringify( O );
				var S = '{', sEnd = '}';
				if (evm.isArray(O)) {
					S = '[';
					sEnd = ']';
				}
				for (var i in O) {
					S += i + ':';
					if (evm.isUndefined(O[i])) S += '""';
					else if (evm.isObject(O[i])) S += evm.json.stringify(O[i]);
					else if (evm.isArray(O[i])) S += evm.json.stringify(O[i]);
					else if (evm.isString(O[i])) S += '"' + O[i] + '"';
					else S += O[i];
					S += ',';
				}
				S = S.substr(0, S.length - 1);
				S += sEnd;
				return S;
			}
		},
		date: {
			format: function (date, F) {
				F = F || 'YYYY-mm-dd HH:ii:ss';
				var o =
				{
					'm+': date.getMonth() + 1	//月
					, 'd+': date.getDate()		//日
					, 'H+': date.getHours()		//时
					, 'i+': date.getMinutes()	//分
					, 's+': date.getSeconds()	//秒
					, 'q+': Math.floor((date.getMonth() + 3) / 3)	//季
					, 'S+': date.getMilliseconds()	//毫秒
					, 'w+': ['0', '1', '2', '3', '4', '5', '6'][date.getDay()]
					, 'W+': ['日', '一', '二', '三', '四', '五', '六'][date.getDay()]
				}
				if (/(Y+)/.test(F)) F = F.replace(RegExp.$1, ( date.getFullYear() + '' ).substr(4 - RegExp.$1.length));
				for (var K in o) {
					if (new RegExp('(' + K + ')').test(F))
						F = F.replace(RegExp.$1
							, ( RegExp.$1.length == 1 ) ? ( o[K] ) : ( (( K == 'S+' ? '000' : '00' ) + o[K]).substr(('' + o[K]).length)));
				}
				return F;
			}
		},
		//项目实用方法
		/**
		 * @param str
		 * prop={prop}
		 * @param {object} obj
		 * {
		 *	'prop':'value'
		 *	}
		 * @returns {*}
		 * prop=value
		 */
		createInterfaceQueryString:function(str,obj){
			if(!str){
				return '';
			}
			if(typeof obj !== 'object'){
				return str;
			}
			for(var prop in obj){
				var reg = new RegExp('\\{'+prop+'\\}','gi');
				str = str.replace(reg,encodeURIComponent(obj[prop]));
			}
			return str;
		},
		marquee:(function(){
			function Marquee(options){
				options = options || {};

				this._timerId = null;
				this._intervalId = null;
				/**
				 * 控制滚动速度
				 * @type {number|*}
				 */
				this.scrollAmount = options.scrollAmount || 2;
			}
			Marquee.prototype.createDOM = function(text,fontSize,height,className){
				if(!text){
					return null;
				}
				fontSize  = fontSize || 22;
				height = height || 30;
				className = className || 'evm-text-marquee';
				var width = (text.length + 8) * fontSize;
				marqueeBox = document.createElement('div');
				marqueeBox.className = className;
				marqueeBox.style.position = 'absolute';
				marqueeBox.style.left = '0';
				marqueeBox.style.top = '0';
				marqueeBox.style.width = width * 2 + 'px';
				marqueeBox.style.height = height + 'px';
				marqueeBox.style.lineHeight = height + 'px';
				marqueeBox.style.textAlign = 'left';
				var html = '<div class="marquee-text" style="display:inline-block;line-height:'+height+'px;float:left;">' + text + '<b>&nbsp;&nbsp;&nbsp;&nbsp;</b></div><div class="marquee-text" style="display:inline-block;line-height:'+height+'px;float:left;">' + text + '<b>&nbsp;&nbsp;&nbsp;&nbsp;</b></div>';
				evm.html(marqueeBox, html);
				return marqueeBox;
			};
			Marquee.prototype.startScroll = function(marqueeBox){
				var me = this;
				me.stopScroll();
				var lineWidth;
				me._timerId = setInterval(function () {
					var lineWidth = evm.getElementsByClassName('marquee-text', 'div', marqueeBox)[0].clientWidth;
					if (lineWidth) {
						me._timerId && clearInterval(me._timerId);
						var left = parseFloat(marqueeBox.style.left);
						var step = -me.scrollAmount;
						me._intervalId = setInterval(function () {
							left += step;
							if (left <= -lineWidth) {
								var lineFirst = evm.getElementsByClassName('marquee-text', 'div', marqueeBox)[0];
								marqueeBox.appendChild(lineFirst);
								marqueeBox.style.left = 0;
								left = 0;
							}
							marqueeBox.style.left = left + 'px';
						}, 40);
					}
				}, 10);
			};
			Marquee.prototype.stopScroll = function(marqueeBox){
				this._intervalId && clearInterval(this._intervalId);
				this._timerId && clearInterval(this._timerId);
				this._intervalId = null;
				this._timerId = null;
				marqueeBox && (marqueeBox.style.left = 0);
			};
			return {
				createInstance:function(options){
					return new Marquee(options);
				}
			};
		})()
	});
})(this);
/**************************************************************************************
 *             按键键值(包含英立视Enrich,茁壮iPanel,天柏DVN,浪潮Inspur)
 /**************************************************************************************/
var util_keymap = {};
util_keymap.pc = {};
util_keymap.enrich = {};
util_keymap.ipanel = {};
util_keymap.dvn = {};
util_keymap.inspur = {};
evm.extend(util_keymap.pc, {
	8: 'BACK'
	, 13: 'SELECT'
	, 37: 'LEFT'
	, 38: 'UP'
	, 39: 'RIGHT'
	, 40: 'DOWN'
	, 81: 'Q'
	, 87: 'W'
	, 69: 'E'
	, 82: 'R'
	, 84: 'T'
	, 89: 'Y'
	, 85: 'U'
	, 73: 'I'
	, 79: 'O'
	, 80: 'P'
	, 65: 'A'
	, 83: 'S'
	, 68: 'D'
	, 70: 'F'
	, 71: 'G'
	, 72: 'H'
	, 74: 'J'
	, 75: 'K'
	, 76: 'L'
	, 90: 'Z'
	, 88: 'X'
	, 67: 'C'
	, 86: 'V'
	, 66: 'B'
	, 78: 'N'
	, 77: 'M'
	, 33: 'PAGE_UP'
	, 34: 'PAGE_DOWN'
	, 48: 'NUM_0'
	, 49: 'NUM_1'
	, 50: 'NUM_2'
	, 51: 'NUM_3'
	, 52: 'NUM_4'
	, 53: 'NUM_5'
	, 54: 'NUM_6'
	, 55: 'NUM_7'
	, 56: 'NUM_8'
	, 57: 'NUM_9'
	,112:'F1'
	,113:'F2'
	,114:'F3'
	,115:'F4'
});
//EnRich
evm.extend(util_keymap.enrich, {
	13: 'SELECT'
	, 87: 'UP'
	, 83: 'DOWN'
	, 65: 'LEFT'
	, 68: 'RIGHT'
	, 8: 'BACK'
	, 27: 'EXIT'
	, 46: 'PREV'
	, 44: 'NEXT'
	, 306: 'PAGE_UP'
	, 307: 'PAGE_DOWN'
	, 320: 'F1'
	, 321: 'F2'
	, 322: 'F3'
	, 323: 'F4'
	, 67: 'MUTE'
	, 76: 'FAV'
	, 77: 'MAIL'
	, 80: 'TV'
	, 73: 'INFO'
	, 69: 'EPG'
	, 61: 'VOL_UP'
	, 45: 'VOL_DOWN'
	, 48: 'NUM_0'
	, 49: 'NUM_1'
	, 50: 'NUM_2'
	, 51: 'NUM_3'
	, 52: 'NUM_4'
	, 53: 'NUM_5'
	, 54: 'NUM_6'
	, 55: 'NUM_7'
	, 56: 'NUM_8'
	, 57: 'NUM_9'
});
//iPanel
evm.extend(util_keymap.ipanel, {
	13: 'SELECT'
	, 1: 'UP'
	, 2: 'DOWN'
	, 3: 'LEFT'
	, 4: 'RIGHT'
	, 340: 'BACK'
	, 339: 'EXIT'
	, 372: 'PAGE_UP'
	, 373: 'PAGE_DOWN'
	, 1029: 'PREV'
	, 1028: 'NEXT'
	, 48: 'NUM_0'
	, 49: 'NUM_1'
	, 50: 'NUM_2'
	, 51: 'NUM_3'
	, 52: 'NUM_4'
	, 53: 'NUM_5'
	, 54: 'NUM_6'
	, 55: 'NUM_7'
	, 56: 'NUM_8'
	, 57: 'NUM_9'
	,832: 'F1'
	,834:'F2'
	,833:'F3'
	,835:'F4'
});
//DVN
evm.extend(util_keymap.dvn, {
	13: 'SELECT'
	, 38: 'UP'
	, 40: 'DOWN'
	, 37: 'LEFT'
	, 39: 'RIGHT'
	, 8: 'BACK'
	, 120: 'PAGE_UP'
	, 121: 'PAGE_DOWN'
	, 601: 'VOL_up'
	, 602: 'VOL_DOWN'
	, 48: 'NUM_0'
	, 49: 'NUM_1'
	, 50: 'NUM_2'
	, 51: 'NUM_3'
	, 52: 'NUM_4'
	, 53: 'NUM_5'
	, 54: 'NUM_6'
	, 55: 'NUM_7'
	, 56: 'NUM_8'
	, 57: 'NUM_9'
});
//Inspur
evm.extend(util_keymap.inspur, {
	13: 'SELECT'
	, 38: 'UP'
	, 40: 'DOWN'
	, 37: 'LEFT'
	, 39: 'RIGHT'
	, 8: 'BACK'
	, 27: 'EXIT'
	, 33: 'PAGE_UP'
	, 34: 'PAGE_DOWN'
	, 36: 'MENU'
	, 67: 'MAIL'
	, 69: 'EPG'
	, 70: 'FAV'
	, 77: 'MUTE'
	, 19: 'PAUSE'
	, 121: 'HDENJOY'
	, 19: 'PLAY'
	, 33: 'PREV'
	, 34: 'NEXT'
	, 112: 'F1'
	, 113: 'F2'
	, 114: 'F3'
	, 115: 'F4'
	, 123: '#'
	, 122: 'STAR'
	, 48: 'NUM_0'
	, 49: 'NUM_1'
	, 50: 'NUM_2'
	, 51: 'NUM_3'
	, 52: 'NUM_4'
	, 53: 'NUM_5'
	, 54: 'NUM_6'
	, 55: 'NUM_7'
	, 56: 'NUM_8'
	, 57: 'NUM_9'
});
/**************************************************************************************
 *                                 机顶盒键值监听
 /**************************************************************************************/
(function(window,evm,undefined){
	//需要项目配置文件中配置util_key.stb
//将具体盒子键值映射对象赋值给util_key.stb
	util_keymap.stb = {};
	/**
	 *    按键事件分发函数
	 * @param {object} event
	 * @param {function} fnGlobalGrabEvent
	 * @param {string} sAlias 可选，用于a标签模拟方向键传入值
	 */
	function grabEvent(event, fnGlobalGrabEvent, sAlias) {
		var keyCode = event.keyCode || event.which;
		var alias = util_keymap.stb[keyCode] || util_keymap.pc[keyCode] || sAlias;
		if (alias == undefined) {
			alias = 'undefined';
		}

		//处理tip提示层
		if(evm.tip.enabled){
			evm.tip.action(alias,event);
			return;
		}

		//优先处理fnGlobalGrabEvent，如果返回为true，直接返回
		if (evm.isFunction(fnGlobalGrabEvent)) {
			if (fnGlobalGrabEvent.call(this, alias) === true) {
				return;
			}
		}
		//向监听组件分发事件
		evm.grabEvent.components.forEach(function (obj) {
			obj.action(alias, event);
		});

		if (evm.grabEvent.preventDefault) {
			evm.preventDefault(event);
		}
	}
	evm.extend(grabEvent, {
		components: [],
		//上一次监听的组件对象
		lastComponent: null,
		//是否阻止按键的默认事件
		preventDefault: 0
	});
	/**
	 * @constructor
	 * @des 监听组件的辅助类，所有组件需要继承该类
	 */
	function KeyListenBase() {
	}
	KeyListenBase.prototype = {
		addListener: function () {
			var me = this;
			var hasFound = false;
			for (var i = 0; i < evm.grabEvent.components.length; i++) {
				if (me === evm.grabEvent.components[i]) {
					hasFound = true;
				}
			}
			if (!hasFound) {
				evm.grabEvent.components.push(this);
			}

			this.isActiveModule = true;

			if (this.focus) {
				this.focus();
			}
		},
		removeListener: function () {
			var me = this;
			var filter = [];
			for (var i = 0; i < evm.grabEvent.components.length; i++) {
				if (me !== evm.grabEvent.components[i]) {
					filter.push(evm.grabEvent.components[i]);
				}
			}
			evm.grabEvent.components = filter;

			this.isActiveModule = false;

			if (this.blur) {
				this.blur();
			}
		},
		/**
		 * @public
		 * 清空所有已经监听组件集
		 */
		flush: function () {
			var leaved = [];
			for(var i = 0;i < evm.grabEvent.components.length;i++){
				var item = evm.grabEvent.components[i];
				if(item !== evm.log){
					item.isActiveModule = false;
					if(item.blur){
						item.blur();
					}
				}
				else{
					leaved.push(evm.grabEvent.components[i]);
				}
			}

			evm.grabEvent.components = leaved;
		},
		setLastComponent: function () {
			evm.grabEvent.lastComponent = this;
		},
		getLastComponent: function () {
			return evm.grabEvent.lastComponent;
		},
		isListened: function () {
			for (var i = 0; i < evm.grabEvent.components.length; i++) {
				if (this === evm.grabEvent.components[i]) {
					return true;
				}
			}
			return false;
		}
	};

	evm.grabEvent = grabEvent;
	evm.KeyListenBase = KeyListenBase;
})(window,window.evm,undefined);
/**************************************************************************************
 *                                 页面元素包装类
 /**************************************************************************************/
/**
 * @des 用于将页面元素包装成可以监听的组件
 * @param {object} options
 * @constructor
 */
function ElementsWrapperForKey(options) {
	this.activeIndex = options.activeIndex || 0;
	this.ids = options.ids;
	//元素响应按键方向
	//H水平 V上下 ALL全部
	this.moveDir = options.moveDir || 'H';
	/**
	 * 设置组件是否活动状态
	 * @type {boolean|*}
	 */
	this.isActiveModule = options.isActiveModule || false;
	/**
	 * 用于表示组件是否可被选中状态
	 * @type {boolean}
	 */
	this.enabled = options.enabled === false ? false : true;
	//配置方法
	this.onFocus = options.onFocus;
	this.onBlur = options.onBlur;
	this.onWidgetInit = options.onWidgetInit;
	this.onWidgetBlur = options.onWidgetBlur;
	this.doSelect = options.doSelect;
	this.onEdit = options.onEdit;
}
extend(ElementsWrapperForKey, evm.KeyListenBase);
evm.extend(ElementsWrapperForKey.prototype, {
	action: function (alias, event) {
		switch (alias) {
			case 'UP':
			case 'RIGHT':
			case 'DOWN':
			case 'LEFT':
				this.move(alias, event);
				break;
			case 'SELECT':
				this.trigger('doSelect', [this.getActiveElement(), this.getActiveId(), alias, event]);
				break;
			case undefined:
				this.focus();
				break;
		}
		this.trigger('onEdit',[alias,event]);
	},
	blur: function () {
		var elm = this.getActiveElement();
		evm.removeClass(elm, 'focus');
		this.trigger('onBlur', [elm]);
	},
	focus: function () {
		var elm = this.getActiveElement();
		evm.addClass(elm, 'focus');
		this.trigger('onFocus', [elm]);
	},
	getActiveElement: function () {
		var id = this.ids[this.activeIndex];
		return evm.$(id);
	},
	getActiveElementPosition: function () {
		var activeElm = this.getActiveElement();
		var pos = evm.getElementPosition(activeElm);
		return pos;
	},
	getActiveId: function () {
		return this.ids[this.activeIndex];
	},
	getActiveIndex: function () {
		return this.activeIndex;
	},
	getIds: function () {
		return this.ids;
	},
	init: function () {
		if (this.isActiveModule) {
			this.addListener();
		}
		this.trigger('onWidgetInit', [this.getActiveId()]);
	},
	setActiveIndex: function (nIndex) {
		this.activeIndex = Math.max(0, Math.min(nIndex, this.ids.length));
	},
	move: function (alias, event) {
		var len = this.ids.length;
		var step = 1;
		var moveDir = this.moveDir;
		if (moveDir === 'V') {
			if (alias === 'UP') step = -1;
			if (alias === 'DOWN') step = 1;
			if (alias === 'LEFT' || alias === 'RIGHT') step = 0;
		}
		else if (moveDir === 'ALL') {
			if (alias === 'UP' || alias === 'LEFT') step = -1;
			if (alias === 'DOWN' || alias === 'RIGHT') step = 1;
		}
		else/*H*/{
			if (alias === 'LEFT') step = -1;
			if (alias === 'RIGHT') step = 1;
			if (alias === 'UP' || alias === 'DOWN') step = 0;
		}
		if (step === 0) {
			this.blur();
			this.trigger('onWidgetBlur', [alias]);
			//如果组件没有失去焦点，自动获取焦点
			if (this.isListened()) {
				this.focus();
			}
			return;
		}
		var ai = this.activeIndex;
		ai += step;
		if (ai >= 0 && ai < len) {
			this.blur();
			this.activeIndex = ai;
			this.focus();
		}
		else {
			this.blur();
			this.trigger('onWidgetBlur', [alias]);
			//如果组件没有失去焦点，自动获取焦点
			if (this.isListened()) {
				this.focus();
			}
		}
	},
	trigger: function (eventName, args) {
		if (typeof this[eventName] === 'function') {
			this[eventName].apply(this, args);
		}
	}
});
/**************************************************************************************
 *                                 页面调试日志类
 *
 * 使用日志类，需要设置siteConfig对象和switchLog属性
 * 例:var siteConfig = {
 * switchLog:true
 * }
 /**************************************************************************************/
function MyLogger(options) {
	if (!options) {
		options = {};
	}
	this.time = null;
	var id = options.id || 'evmLogWindow';
	this._logWindow = null;
	this._innerLogWindow = null;
	//修正调试窗口上和右位置
	this.top = options.top || 60;
	this.right = options.right || 60;
	var browserWindowSize = evm.getBrowserWindowSize();
	/**
	 * 设置调试窗口宽度
	 * @type {number}
	 */
	this.width = browserWindowSize.width * 1 / 3 - 2;
	/**
	 * 设置调试窗口高度
	 * @type {number}
	 */
	this.height = parseInt((browserWindowSize.height - 2 * this.top) / 33) * 33;
	/**
	 * 保存组合键命令
	 * @type {Array}
	 * @private
	 */
	this._aliasArray = [];
	/**
	 * 调试窗口组合键
	 * @type {.message.cmd|*|{}|cmd}
	 */
	this.cmd = options.cmd || {};
	/**
	 * 保存所有组合键的alias
	 * @type {Array}
	 * @private
	 */
	this._allCmd = [];
	for (var prop in this.cmd) {
		for (var i = 0; i < this.cmd[prop].length; i++) {
			this._allCmd.push(this.cmd[prop][i]);
		}
	}
	this._switchLog = false;
	var me = this;
	var createWindow = function () {
		var top = me.top;
		var right = me.right;
		var logWindow;
		//创建作为日志窗口的DOM节点
		logWindow = document.createElement('DIV');
		logWindow.setAttribute('id', id);
		logWindow.className = 'log-hide';
		logWindow.style.position = 'absolute';
		logWindow.style.right = -(me.width) + 'px';
		logWindow.style.top = top + 'px';
		logWindow.style.width = me.width + 'px';
		logWindow.style.height = me.height + 'px';
		logWindow.style.overflow = 'hidden';
		logWindow.style.padding = '0';
		logWindow.style.margin = '0';
		logWindow.style.border = '1px solid #6fb500';
		logWindow.style.background = '#0A200B';
		logWindow.style.listStyle = 'none';
		logWindow.style.webkitTransitionDuration = '200ms';
		logWindow.style.zIndex = '1000';
		me._innerLogWindow = document.createElement('UL');
		me._innerLogWindow.style.position = 'relative';
		me._innerLogWindow.style.top = '0';
		me._innerLogWindow.style.left = '10px';
		me._innerLogWindow.style.width = me.width - 20 + 'px';
		logWindow.appendChild(me._innerLogWindow);
		//将其添加到文档中
		document.body.appendChild(logWindow);
		me._logWindow = logWindow;
		//加入按键监听该组件
		me.addListener();
	};
	this.writeRaw = function (message) {
		//日志依赖项目配置文件
		if (siteConfig && siteConfig.switchLog) {
			if (!this._logWindow) createWindow();
			//创建列表项并适当的添加样式
			var li = document.createElement('LI');
			li.style.border = '0';
			li.style.margin = '0';
			li.style.color = '#6fb500';
			li.style.font = '22px/33px Verdana,Tahoma,Sans';
			this._innerLogWindow.appendChild(li);

			var timeSpan = document.createElement('SPAN');
			timeSpan.className = 'evmLogWindow-time';
			timeSpan.style.display = 'inline-block';
			timeSpan.style.width = '200px';
			timeSpan.style.color = '#FF8500';
			this.time = new Date();
			evm.text(timeSpan, '[' + evm.date.format(this.time, 'HH:ii:ss SSS') + ']');
			li.appendChild(timeSpan);

			var messageSpan = document.createElement('SPAN');
			messageSpan.style.wordBreak = 'break-all';
			messageSpan.style.wordWrap = 'break-word';

			//为日志添加信息节点
			if (message == 'undefined') {
				messageSpan.appendChild(document.createTextNode('Message was undefined!'));
			}
			else if (typeof li.innerHTML != undefined) {
				messageSpan.innerHTML = message;
			}
			else {
				messageSpan.appendChild(document.createTextNode(message));
			}
			li.appendChild(messageSpan);

			return true;
		}
	};
	this.clearAll = function () {
		return evm.removeChildren(this._logWindow);
	};
	/**
	 * 隐藏或者显示调试窗口
	 * @private
	 */
	this._toggle = function () {
		if (this._logWindow) {
			if (this._logWindow.className === 'log-hide') {
				this._logWindow.className = 'log-show';
				this._logWindow.style.right = this.right + 'px';
			}
			else {
				this._logWindow.className = 'log-hide';
				this._logWindow.style.right = -(this.width) + 'px';
			}
		}
	}
}
extend(MyLogger, evm.KeyListenBase);
evm.extend(MyLogger.prototype, {
	action: function (alias, event) {
		this._switchLog = siteConfig && siteConfig.switchLog;
		var cmd = this._checkCmd(alias);
		switch (cmd) {
			case 'toggle':
				if (this._switchLog) {
					this._toggle();
				}
				break;
			case 'prev':
				this.prev();
				break;
			case 'next':
				this.next();
				break;
		}
	},
	write: function (message) {
		//警告message为空值
		if (typeof message == 'string' && message.length === 0) {
			return this.writeRaw('evm.log:null message');
		}
		//如果message不是string，尝试调用toString方法
		if (typeof message != 'string') {
			if (message.toString) {
				return this.writeRaw(message.toString());
			}
			else {
				return this.writeRaw(typeof message);
			}
		}
		//转换<和>以便.innerHTML不会将message做为HTML进行解析
		message = message.replace(/</g, '&lt;').replace(/>/g, '&gt;');
		return this.writeRaw(message);
	},
	header: function (message) {
		message = '<span style="color:white;background-color:#000;font-weight:bold;padding:0 5px;">' + message + '</span>';
		return this.writeRaw(message);
	},
	next: function () {
		if (this._logWindow.className = 'log-show') {
			var _innerLogWindow = this._innerLogWindow;
			var innerHeight = parseFloat(evm.getStyle(_innerLogWindow, 'height')) || _innerLogWindow.clientHeight;
			var top = parseFloat(_innerLogWindow.style.top);
			var step = this.height;
			if (top - step >= - innerHeight) {
				_innerLogWindow.style.top = top - step + 'px';
			}
		}
	},
	prev: function () {
		if (this._logWindow.className = 'log-show') {
			var _innerLogWindow = this._innerLogWindow;
			var top = parseFloat(_innerLogWindow.style.top);
			var step = this.height;
			if (top + step <= 0) {
				_innerLogWindow.style.top = top + step + 'px';
			}
		}
	},
	/**
	 * 返回第一个满足命令的属性名称
	 * @param alias
	 * @returns {string}
	 * @private
	 */
	_checkCmd: function (alias) {
		var hasFound = false;
		for (var i = 0; i < this._allCmd.length; i++) {
			if (alias === this._allCmd[i]) {
				hasFound = true;
				break;
			}
		}
		if (!hasFound) {
			this._aliasArray = [];
			return '';
		}
		else {
			this._aliasArray.push(alias);
		}
		var pass;
		for (var prop in this.cmd) {
			pass = true;
			if (this._aliasArray.length === this.cmd[prop].length) {
				for (var i = 0; i < this._aliasArray.length; i++) {
					if (this._aliasArray[i] !== this.cmd[prop][i]) {
						pass = false;
					}
				}
				if (pass) {
					this._aliasArray = [];
					return prop;
				}
			}
		}
		return '';
	}
});
evm.log = new MyLogger({
	top: 30,
	right: 50,
	cmd: {
		//控制调试窗口显示或隐藏
		toggle: ['NUM_0', 'NUM_0', 'NUM_0', 'NUM_0'],
		prev: ['PAGE_UP','PREV'],
		next: ['PAGE_DOWN','NEXT']
	}
});

/**************************************************************************************
 *                               页面弹出提示层组件
 * 支持三种操作模式
 * simple,logical,callback
 /**************************************************************************************/
function TipLayer(options){
	options = options || {};
	//按钮控件
	this.buttonsComponent = null;
	/**
	 * 默认组件不可用状态
	 * @type {boolean}
	 */
	this.enabled = false;
	this._tipLayerWindow = null;
	this._textBox = null;
	this._simpleView = null;
	this._logicalView = null;
	this._callbackView = null;
	/**
	 * 保存logical操作传入的回调函数
	 * @type {null}
	 * @private
	 */
	this._callback = null;
	this.width = options.width || 465;
	this.height = options.height || 205;
	/**
	 * 操作模式类型
	 * @type {string}
	 * @private
	 */
	this._type = 'simple';
	this.template = options.template || {
		bg:'url(/swatapps/ape/widget-v2/img/tipLayer-bg.png)',
		simple:{
			ok:'/swatapps/ape/widget-v2/img/simple-ok.png'
		}
	}
}
evm.extend(TipLayer.prototype,{
	action:function(alias){
		switch(alias){
			case 'SELECT':
				this.hide();
				this.enabled = false;
				break;
		}
	},
	hide:function(){
		evm.hide(this._tipLayerWindow);
	},
	callback:function(str,cb){
		this.enabled = true;
		this._type = 'callback';
		this._write(str);
	},
	logical:function(str,cb){
		this.enabled = true;
		this._type = 'logical';
		this._write(str);
	},
	show:function(){
		evm.show(this._tipLayerWindow);
	},
	simple:function(str){
		this.enabled = true;
		this._type = 'simple';
		this._write(str);
	},
	_create:function(str){
		this._tipLayerWindow = document.createElement('DIV');
		this._tipLayerWindow.className = 'tipLayer';
		this._tipLayerWindow.style.position = 'absolute';
		this._tipLayerWindow.style.zIndex = '10000';
		this._tipLayerWindow.style.width = this.width + 'px';
		this._tipLayerWindow.style.height = this.height + 'px';
		this._tipLayerWindow.style.left = (1280 - this.width)/2 + 'px';
		this._tipLayerWindow.style.top = (720 - this.height)/2 + 'px';
		this._tipLayerWindow.style.backgroundImage = this.template.bg;
		this._tipLayerWindow.style.webkitTransitionDuration = '100ms';

		var textElm = document.createElement('DIV');
		textElm.className = 'tipLayer-text';
		textElm.style.position = 'absolute';
		textElm.style.left = '9px';
		textElm.style.top = '19px';
		textElm.style.width = '447px';
		textElm.style.height = '90px';
		textElm.style.fontSize = '30px';
		textElm.style.textAlign = 'center';

		evm.html(textElm,str);
		this._tipLayerWindow.appendChild(textElm);
		this._textBox = textElm;

		var operateBox = document.createElement('DIV');
		operateBox.className='tipLayer-operate';
		evm.html(operateBox,'<div class="tipLayer-simple" style="position:absolute;top:148px;left:9px;width:447px;height:40px;text-align:center;"><span class="tipLayer-simple-ok" style="display:inline-block;width:143px;height:40px;background:transparent url('+ this.template.simple.ok +') no-repeat left top;"></span></div><div class="tipLayer-logical"><span class="tipLayer-logical-ok"></span><span class="tipLayer-logical-cancel"></span></div><div class="tipLayer-callback"><span class="tipLayer-callback-ok"></span></div>');
		this._tipLayerWindow.appendChild(operateBox);

		this._simpleView = evm.getElementsByClassName('tipLayer-simple','div',this._tipLayerWindow)[0];
		this._logicalView = evm.getElementsByClassName('tipLayer-logical','div',this._tipLayerWindow)[0];
		this._callbackView = evm.getElementsByClassName('tipLayer-callback','div',this._tipLayerWindow)[0];

		var viewBox = evm.$('container') || document.getElementsByTagName('body')[0];
		viewBox.appendChild(this._tipLayerWindow);
	},
	_write:function(str){
		if(!this._tipLayerWindow){
			this._create(str);
		}
		else{
			this.show();
			evm.hide(this._simpleView);
			evm.hide(this._logicalView);
			evm.hide(this._callbackView);

			switch (this._type){
				case 'simple':
					evm.show(this._simpleView);
					break;
				case 'logical':
					evm.show(this._logicalView);
					break;
				case 'callback':
					evm.show(this._callbackView);
					break;
			}

			evm.html(this._textBox,str);
		}

	}
});
evm.tip = new TipLayer();