/*
 * 四川 高清&APK
 */
var evm;
(function(evm) {
  var PlayerModule;
  (function(PlayerModule) {
    // 可订阅事件
    PlayerModule.EVENT_TYPE = {
      CHANGE_MUTE: 'CHANGE_MUTE',
      CHANGE_SEEK: 'CHANGE_SEEK',
      CHANGE_SCALE: 'CHANGE_SCALE',
      CHANGE_POSITION: 'CHANGE_POSITION',
      CHANGE_VOLUME: 'CHANGE_VOLUME',
      CHANGE_SOURCE: 'CHANGE_SOURCE',
      CHANGE_CURRENT_TIME: 'CHANGE_CURRENT_TIME',
      FUNC_INIT: 'FUNC_INIT',
      FUNC_INIT_SUCCESS: 'FUNC_INIT_SUCCESS',
      FUNC_INIT_ERROR: 'FUNC_INIT_ERROR',
      FUNC_PLAY: 'FUNC_PLAY',
      FUNC_PLAY_SUCCESS: 'FUNC_PLAY_SUCCESS',
      FUNC_PLAY_ERROR: 'FUNC_PLAY_ERROR',
      FUNC_STOP: 'FUNC_STOP',
      FUNC_STOP_SUCCESS: 'FUNC_STOP_SUCCESS',
      FUNC_STOP_ERROR: 'FUNC_STOP_ERROR',
      FUNC_PAUSE: 'FUNC_PAUSE',
      FUNC_PAUSE_SUCCESS: 'FUNC_PAUSE_SUCCESS',
      FUNC_PAUSE_ERROR: 'FUNC_PAUSE_ERROR',
      FUNC_RESUME: 'FUNC_RESUME',
      FUNC_RESUME_SUCCESS: 'FUNC_RESUME_SUCCESS',
      FUNC_RESUME_ERROR: 'FUNC_RESUME_ERROR',
      FUNC_SEEK: 'FUNC_SEEK',
      FUNC_SEEK_SUCCESS: 'FUNC_SEEK_SUCCESS',
      FUNC_SEEK_ERROR: 'FUNC_SEEK_ERROR',
      FUNC_SCALE: 'FUNC_SCALE',
      FUNC_SCALE_SUCCESS: 'FUNC_SCALE_SUCCESS',
      FUNC_SCALE_ERROR: 'FUNC_SCALE_ERROR',
      FUNC_SET_POSITION: 'FUNC_SET_POSITION',
      FUNC_SET_POSITION_SUCCESS: 'FUNC_SET_POSITION_SUCCESS',
      FUNC_SET_POSITION_ERROR: 'FUNC_SET_POSITION_ERROR',
      FUNC_GET_MUTE: 'FUNC_GET_MUTE',
      FUNC_GET_MUTE_SUCCESS: 'FUNC_GET_MUTE_SUCCESS',
      FUNC_GET_MUTE_ERROR: 'FUNC_GET_MUTE_ERROR',
      FUNC_MUTE: 'FUNC_MUTE',
      FUNC_MUTE_SUCCESS: 'FUNC_MUTE_SUCCESS',
      FUNC_MUTE_ERROR: 'FUNC_MUTE_ERROR',
      FUNC_UNMUTE: 'FUNC_UNMUTE',
      FUNC_UNMUTE_SUCCESS: 'FUNC_UNMUTE_SUCCESS',
      FUNC_UNMUTE_ERROR: 'FUNC_UNMUTE_ERROR',
      FUNC_GET_CURRENT_TIME: 'FUNC_GET_CURRENT_TIME',
      FUNC_GET_CURRENT_TIME_SUCCESS: 'FUNC_GET_CURRENT_TIME_SUCCESS',
      FUNC_GET_CURRENT_TIME_ERROR: 'FUNC_GET_CURRENT_TIME_ERROR',
      FUNC_GET_DURATION: 'FUNC_GET_DURATION',
      FUNC_GET_DURATION_SUCCESS: 'FUNC_GET_DURATION_SUCCESS',
      FUNC_GET_DURATION_ERROR: 'FUNC_GET_DURATION_ERROR',
      FUNC_GET_VOLUME: 'FUNC_GET_VOLUME',
      FUNC_GET_VOLUME_SUCCESS: 'FUNC_GET_VOLUME_SUCCESS',
      FUNC_GET_VOLUME_ERROR: 'FUNC_GET_VOLUME_ERROR',
      FUNC_SET_VOLUME: 'FUNC_SET_VOLUME',
      FUNC_SET_VOLUME_SUCCESS: 'FUNC_SET_VOLUME_SUCCESS',
      FUNC_SET_VOLUME_ERROR: 'FUNC_SET_VOLUME_ERROR',
      FUNC_DESTROY: 'FUNC_DESTROY',
      FUNC_DESTROY_SUCCESS: 'FUNC_DESTROY_SUCCESS',
      FUNC_DESTROY_ERROR: 'FUNC_DESTROY_ERROR',
      FUNC_SET_SOURCE: 'FUNC_SET_SOURCE',
      FUNC_SET_SOURCE_SUCCESS: 'FUNC_SET_SOURCE_SUCCESS',
      FUNC_SET_SOURCE_ERROR: 'FUNC_SET_SOURCE_ERROR',
      FUNC_TRIM_SOURCE: 'FUNC_TRIM_SOURCE',
      FUNC_TRIM_SOURCE_SUCCESS: 'FUNC_TRIM_SOURCE_SUCCESS',
      FUNC_TRIM_SOURCE_ERROR: 'FUNC_TRIM_SOURCE_ERROR',
      FUNC_FULLSCREEN: 'FUNC_FULLSCREEN',
      FUNC_FULLSCREEN_SUCCESS: 'FUNC_FULLSCREEN_SUCCESS',
      FUNC_FULLSCREEN_ERROR: 'FUNC_FULLSCREEN_ERROR',
      FUNC_BIND_SYSTEM_EVENT: 'FUNC_BIND_SYSTEM_EVENT',
      FUNC_BIND_SYSTEM_EVENT_SUCCESS: 'FUNC_BIND_SYSTEM_EVENT_SUCCESS',
      FUNC_BIND_SYSTEM_EVENT_ERROR: 'FUNC_BIND_SYSTEM_EVENT_ERROR',
      FUNC_SYSTEM_EVENT: 'FUNC_SYSTEM_EVENT',
      FUNC_SYSTEM_EVENT_SUCCESS: 'FUNC_SYSTEM_EVENT_SUCCESS',
      FUNC_SYSTEM_EVENT_ERROR: 'FUNC_SYSTEM_EVENT_ERROR'
    };
    // Player类
    var Player = (function() {
      function Player(config) {
        // 判断STB类型
        var UA = navigator.userAgent.toLowerCase();

        evm.makePublisher(this);
        Player.self = this;
        this.isAndroid = /android/.test(UA);
        this.mp = null;
        this.mpInstanceId = 0;
        this.config = config;
        this.playSource = config.playSource || '';
        this.volume = config.volume || Player.defaultConfig.volume;
        this.maxVolume = config.maxVolume || Player.defaultConfig.maxVolume;

        if (this.maxVolume == 100) {
          this.volumeStep = config.volumeStep?config.volumeStep:5;
        } else {
          this.volumeStep = config.volumeStep?config.volumeStep:Player.defaultConfig.volumeStep;
        }

        if (typeof config.isMute == "number") {
          if (config.isMute < 0 || config.isMute > 1) {
            throw new Error("isMute取值范围0或1");
          }
          this.isMute = config.isMute;
        } else {
          this.isMute = Player.defaultConfig.isMute;
        }

        if (typeof config.isFullscreen == "number") {
          if (config.isFullscreen < 0 || config.isFullscreen > 1) {
            throw new Error("isFullscreen取值范围0或1");
          }
          this.isFullscreen = config.isFullscreen;
        } else {
          this.isFullscreen = Player.defaultConfig.isFullscreen;
        }

        if (typeof config.isLoop == "number") {
          if (config.isLoop < 0 || config.isLoop > 1) {
            throw new Error("isLoop取值范围0或1");
          }
          this.isLoop = config.isLoop;
        } else {
          this.isLoop = Player.defaultConfig.isLoop;
        }

        if (typeof config.loopLimit == "number") {
          if (config.loopLimit < 0) {
            throw new Error("loopLimit不能小于0");
          }
          this.loopLimit = config.loopLimit;
        } else {
          this.loopLimit = Player.defaultConfig.loopLimit;
        }

        if (typeof config.unit == "string") {
          var result = this.find(
            config.unit,
            Player.defaultConfig.valueUnits
          );
          if (result < 0) {
            throw new Error("unit配置参数错误");
          }
          this.setUnit(config.unit);
        } else {
          var result = this.find(
            Player.defaultConfig.unit,
            Player.defaultConfig.valueUnits
          );
          if (result < 0) {
            throw new Error("unit默认配置错误");
          }
          this.setUnit(Player.defaultConfig.unit);
        }

        this.stbProtocolSupport = config.stbProtocolSupport || [];

        if (this.stbProtocolSupport.length && !config.stbProtocol) {
          throw new Error("未配置stbProtocol");
        }

        this.currentStbProtocol = config.stbProtocol;

        if (this.currentStbProtocol) {
          this.currentStbProtocolIdx = this.find(
            this.currentStbProtocol, this.stbProtocolSupport
          );
          if (this.currentStbProtocolIdx < 0) {
            throw new Error("配置项stbProtocol错误");
          }
        }

        this.playModeSupport = config.playModeSupport || [];

        if (this.playModeSupport.length && !config.playMode) {
          throw new Error("未配置playMode");
        }

        this.currentPlayMode = config.playMode;

        if (this.currentPlayMode) {
          this.currentPlayModeIdx = this.find(
            this.currentPlayMode, this.playModeSupport
          );
          if (this.currentPlayModeIdx < 0) {
            throw new Error("配置项playMode错误");
          }
        }

        //  播放器方法在此处扩展
        evm.extend(this, {
          init: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_INIT, null);

            if (this.isAndroid) {
            } else {
              try {
                this.mp = new MediaPlayer();
                if (GlobalVarManager.getItemValue("PLAYER_INSTANCE_ID") == null) {
                  this.mpInstanceId = this.mp.getPlayerInstanceID();
                  GlobalVarManager.setItemValue(
                    "PLAYER_INSTANCE_ID",
                    this.mpInstanceId
                  );
                } else {
                  this.mpInstanceId = GlobalVarManager.getItemValue(
                    "PLAYER_INSTANCE_ID"
                  );
                }
                this.mp.bindPlayerInstance(this.mpInstanceId);
              } catch (e) {}
            }

            this.getVolume(null, function (vol) {
              if (!vol) {
                Player.self.volume = 0;
              }
            });

            if (typeof callback == 'function') {
              callback.call(callback);
            }
          },
          setSource: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_SET_SOURCE, null);
            var argNo = 0;

            for (var arg in params) {
              if ((arg == 'address') || (arg == 'token') || (arg == 'playUrl')) {
                argNo += 1;
              }
            }

            if (argNo == 0) {
              throw new Error('setSource方法配置对象可配置参数: playUrl|address|token|extension');
            }

            if (argNo > 1) {
              this.playSource = this.trimSource(params);
            } else if (argNo == 1) {
              if (params.playUrl) {
                this.playSource = params.playUrl;
              } else {
                throw new Error('setSource方法配置对象: playUrl不能为空');
              }
            }

            if (this.isAndroid) {
              try {
                media.play(this.playSource);
              } catch (e) {}
            } else {
              try {
                this.mp.enableTrickMode(true);
                this.mp.setMediaSource(this.playSource);
              } catch (e) {}
            }

            if (typeof callback == 'function') {
              callback.call(callback);
            }
          },
          trimSource: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_TRIM_SOURCE, null);
            var source = '';

            if (!params.address || !params.token) {
              throw new Error('trimSource方法配置对象参数: address和token不能为空');
            }

            if (this.isAndroid) {
              source = params.address+'/'+params.token+
                (params.extension?params.extension:'');
            } else {
              source = params.address+'/;purchaseToken='+params.token+
                (params.extension?params.extension:'')+'&paddingOpen=1;serverID=?AppPath=60010001&assetUID=3bca6a47&smartcard-id=8280203837479710&device-id=8280203837479710&home-id=117102057054&purchase-id=4630717&streamtransportmode=ip;';
            }

            if (typeof callback == 'function') {
              callback.call(callback);
            }

            return source;
          },
          play: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_PLAY, null);
            if (this.isAndroid) {
            } else {
              try {
                this.mp.play();
              } catch (e) {}
            }

            if (typeof callback == 'function') {
              callback.call(callback);
            }
          },
          stop: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_STOP, null);

            if (this.playSource) {
              this.playSource = '';

              if (this.isAndroid) {
                try {
                  media.stop();
                } catch (e) {}
              } else {
                try {
                  this.mp.setPauseMode(0);
                  this.mp.stop();
                } catch (e) {}
              }
            }

            if (typeof callback == 'function') {
              callback.call(callback);
            }
          },
          pause: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_PAUSE, null);
            if (this.isAndroid) {
            } else {
              try {
                this.mp.pause();
              } catch (e) {}
            }

            if (typeof callback == 'function') {
              callback.call(callback);
            }
          },
          resume: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_RESUME, null);
            if (this.isAndroid) {
            } else {
              try {
                this.mp.resume();
              } catch (e) {}
            }

            if (typeof callback == 'function') {
              callback.call(callback);
            }
          },
          seek: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_SEEK, null);
            if (this.isAndroid) {
            } else {
              try {
                this.mp.seek(1, params.seekTime + "-");
              } catch (e) {}
            }

            if (typeof callback == 'function') {
              callback.call(callback);
            }
          },
          scale: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_SCALE, null);
            if (this.isAndroid) {
            } else {
            }
          },
          getCurrentTime: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_GET_CURRENT_TIME, null);
            var currentTime = 0;
            if (this.isAndroid) {
            } else {
              try {
                currentTime = this.mp.getCurrentPlayTime();
              } catch (e) {}
            }

            if (typeof callback == 'function') {
              callback.call(callback, currentTime);
            }
            return currentTime;
          },
          getDuration: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_GET_DURATION, null);
            var totalTime = 0;
            if (this.isAndroid) {
            } else {
              try {
                totalTime = this.mp.getDuration();
              } catch (e) {}
            }

            if (typeof callback == 'function') {
              callback.call(callback, totalTime);
            }
            return totalTime;
          },
          setPosition: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_SET_POSITION, null);
            if (this.isAndroid) {
              try {
                media.setPosition(params.left, params.top, params.width, params.height);
              } catch (e) {}
            } else {
              try {
                var rectangle = new Rectangle(
                  params.left,
                  params.top,
                  params.width,
                  params.height
                );
                this.mp.setVideoDisplayArea(rectangle);
                this.mp.setVideoDisplayMode(0);
                this.mp.refresh();
              } catch (e) {}
            }

            if (typeof callback == 'function') {
              callback.call(callback);
            }
          },
          fullscreen: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_FULLSCREEN, null);
            if (this.isAndroid) {
              try {
                media.setPosition(0, 0, 1280, 720);
              } catch (e) {}
            } else {
              try {
                this.mp.setVideoDisplayMode(1);
                this.mp.refresh();
              } catch (e) {}
            }

            if (typeof callback == 'function') {
              callback.call(callback);
            }
          },
          getVolume: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_GET_VOLUME, null);
            var vol;
            if (this.isAndroid) {
            } else {
              try {
                vol = this.mp.getVolume();
              } catch (e) {}

              if (vol) {
                this.volume = vol;
              }
            }

            if (typeof callback == 'function') {
              callback.call(callback, vol);
            }
            return vol;
          },
          setVolume: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_SET_VOLUME, null);
            if (this.isAndroid) {
            } else {
              this.volume = Math.ceil(params.value);
              try {
                this.mp.setVolume(this.volume);
              } catch (e) {}
            }

            if (typeof callback == 'function') {
              callback.call(callback);
            }
          },
          getMute: function () {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_GET_MUTE, null);
            if (this.isAndroid) {
            } else {
            }
          },
          mute: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_MUTE, null);
            if (this.isAndroid) {
            } else {
              this.isMute = 1;
              try {
                AudioSetting.mute();
              } catch (e) {}
            }

            if (typeof callback == 'function') {
              callback.call(callback);
            }
          },
          unmute: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_UNMUTE, null);
            if (this.isAndroid) {
            } else {
              this.isMute = 0;
              try {
                AudioSetting.unMute();
              } catch (e) {}
            }

            if (typeof callback == 'function') {
              callback.call(callback);
            }
          },
          destroy: function (params, callback) {
            var self = Player.self;

            this.emit(PlayerModule.EVENT_TYPE.FUNC_DESTROY, null);
            if (this.isAndroid) {
			  this.stop(null);
            } else {
              this.stop(null, function () {
                if (self.mpInstanceId) {
                  try {
                    self.mp.unbindPlayerInstance(this.mpInstanceId);
                  } catch (e) {}
                  self.mp = null;
                  self.mpInstanceId = "";
                  self.playSource = '';
                }
              });
            }
            if (typeof callback == 'function') {
              callback.call(callback);
            }
          },
          bindSystemEvent: function (params, callback) {
            this.emit(PlayerModule.EVENT_TYPE.FUNC_BIND_SYSTEM_EVENT, null);
            if (this.isAndroid) {
            } else {
              try {
                document.onsystemevent = this.systemEvent;
              } catch (e) {}
            }

            if (typeof callback == 'function') {
              callback.call(callback);
            }
          },
          systemEvent: function (evt) {
            var self = Player.self,
              isBlock = 0,
              code = evt.which;

            self.emit(PlayerModule.EVENT_TYPE.FUNC_SYSTEM_EVENT, null);

            switch (code) {
              case 5974:
                // EIS_MISC_HTML_OPEN_FINISHED
                break;
              case 13001:
                self.play();
                break;
              case 5202:
                // VOD_PREPAREPLAY_SUCCESS
                break;
              case 5205:
                // EIS_VOD_PLAY_SUCCESS
                break;
              case 5210:
                // EIS_VOD_PROGRAM_END
                break;
            }
            return isBlock;
          }
        });
      }

      // 不可修改的默认配置项
      Player.defaultConfig = {
        width: 400,
        height: 300,
        offsetX: 60,
        offsetY: 60,
        fullscreenWidth: 1280,
        fullscreenHeight: 720,
        fullscreenOffsetX: 0,
        fullscreenOffsetY: 0,
        scaleX: 0,
        scaleY: 0,
        scaleWidth: 1,
        scaleHeighgt: 1,
        fullscreenScaleX: 0.05,
        fullscreenScaleY: 0.05,
        fullscreenScaleWidth: 1,
        fullscreenScaleHeight: 1,
        isFullscreen: 1,
        isLoop: 0,
        isMute: 0,
        loopLimit: 0,
        volume: 16,
        volumeStep: 2,
        maxVolume: 32,
        unit: "number",
        valueUnits: ["number", "scale"]
      };

      Player.prototype.find = function(target, source, callback) {
        var i, len, result = -1;

        for (i = 0, len = source.length; i < len; i++) {
          if (source[i] == target) {
            result = i;
            break;
          }
        }
        if (typeof callback == "function") {
          callback.call(callback, result);
        }
        return result;
      };

      Player.prototype.setUnit = function(type, callback) {
        if (this.currentUnit != type) {
          this.currentUnit = type;
          this.initUnit();
          return true;
        }
        return false;
      };

      Player.prototype.getUnit = function() {
        return this.currentUnit;
      };

      Player.prototype.initUnit = function() {
        var config = this.config;

        if (this.currentUnit == "number") {
          if (typeof config.width == "number") {
            if (
              config.width < 0 ||
              config.width > Player.defaultConfig.fullscreenWidth
            ) {
              throw new Error(
                "width配置范围0到" + Player.defaultConfig.fullscreenWidth
              );
            }
            this.width = config.width;
          } else {
            this.width = this.isFullscreen
              ? Player.defaultConfig.fullscreenWidth
              : Player.defaultConfig.width;
          }
          if (typeof config.height == "number") {
            if (
              config.height < 0 ||
              config.height > Player.defaultConfig.fullscreenHeight
            ) {
              throw new Error(
                "height配置范围0到" + Player.defaultConfig.fullscreenHeight
              );
            }
            this.height = config.height;
          } else {
            this.height = this.isFullscreen
              ? Player.defaultConfig.fullscreenHeight
              : Player.defaultConfig.height;
          }
          if (typeof config.offsetX == "number") {
            if (
              config.offsetX < 0 ||
              config.offsetX > Player.defaultConfig.fullscreenWidth
            ) {
              throw new Error(
                "offsetX配置范围0到" + Player.defaultConfig.fullscreenWidth
              );
            }
            this.offsetX = config.offsetX;
          } else {
            this.offsetX = this.isFullscreen
              ? Player.defaultConfig.fullscreenOffsetX
              : Player.defaultConfig.offsetX;
          }
          if (typeof config.offsetY == "number") {
            if (
              config.offsetY < 0 ||
              config.offsetY > Player.defaultConfig.fullscreenHeight
            ) {
              throw new Error(
                "offsetX配置范围0到" + Player.defaultConfig.fullscreenHeight
              );
            }
            this.offsetY = config.offsetY;
          } else {
            this.offsetY = config.offsetY;
            this.offsetY = this.isFullscreen
              ? Player.defaultConfig.fullscreenOffsetY
              : Player.defaultConfig.offsetY;
          }
        } else if (this.currentUnit == "scale") {
          if (typeof config.width == "number") {
            if (
              config.width < 0 ||
              config.width > Player.defaultConfig.fullscreenWidth
            ) {
              throw new Error(
                "width配置范围0到" + Player.defaultConfig.fullscreenWidth
              );
            }
            this.width = config.width;
            this.scaleWidth =
              config.width / Player.defaultConfig.fullscreenWidth;
          } else {
            this.scaleWidth = this.isFullscreen
              ? 1
              : Player.defaultConfig.scaleWidth;
          }
          if (typeof config.height == "number") {
            if (
              config.height < 0 ||
              config.height > Player.defaultConfig.fullscreenHeight
            ) {
              throw new Error(
                "height配置范围0到" + Player.defaultConfig.fullscreenHeight
              );
            }
            this.height = config.height;
            this.scaleHeight =
              config.height / Player.defaultConfig.fullscreenHeight;
          } else {
            this.scaleHeight = this.isFullscreen
              ? 1
              : Player.defaultConfig.scaleHeighgt;
          }
          if (typeof config.offsetX == "number") {
            if (
              config.offsetX < 0 ||
              config.offsetX > Player.defaultConfig.fullscreenWidth
            ) {
              throw new Error(
                "offsetX配置范围0到" + Player.defaultConfig.fullscreenWidth
              );
            }
            this.offsetX = config.offsetX;
            this.scaleX = config.offsetX / Player.defaultConfig.fullscreenWidth;
          } else {
            this.scaleX = this.isFullscreen
              ? Player.defaultConfig.fullscreenScaleX
              : Player.defaultConfig.scaleX;
          }
          if (typeof config.offsetY == "number") {
            if (
              config.offsetY < 0 ||
              config.offsetY > Player.defaultConfig.fullscreenHeight
            ) {
              throw new Error(
                "offsetX配置范围0到" + Player.defaultConfig.fullscreenHeight
              );
            }
            this.offsetY = config.offsetY;
            this.scaleY =
              config.offsetY / Player.defaultConfig.fullscreenHeight;
          } else {
            this.scaleY = this.isFullscreen
              ? Player.defaultConfig.fullscreenScaleY
              : Player.defaultConfig.scaleY;
          }
        }
      };

      Player.prototype.getStbProtocol = function(callback) {
        var result = this.find(this.currentStbProtocol, this.stbProtocolSupport),
          res = '';
        if (result >= 0) {
          this.currentStbProtocolIdx = result;
          res = this.currentStbProtocol;
        } else {
          throw new Error('未定义机顶盒协议');
        }

        if (typeof callback == "function") {
          callback.call(callback, res);
        }
        return res;
      };

      Player.prototype.setStbProtocol = function(type, callback) {
        var result = -1, res = false;
        if (typeof type == 'string' && this.stbProtocolSupport.length) {
          result = this.find(type, this.stbProtocolSupport);
        }
        if (result >= 0) {
          this.currentStbProtocolIdx = result;
          this.currentStbProtocol = this.stbProtocolSupport[result];
          res = true;
        }
        if (typeof callback == "function") {
          callback.call(callback, res);
        }
        return res;
      };

      Player.prototype.getPlayMode = function(callback) {
        var result = this.find(this.currentPlayMode, this.playModeSupport),
          res = '';
        if (result >= 0) {
          this.currentPlayModeIdx = result;
          res = this.currentPlayMode;
        } else {
          throw new Error('未定义播放模式');
        }

        if (typeof callback == "function") {
          callback.call(callbck, res);
        }
        return res;
      };

      Player.prototype.setPlayMode = function(mode, callback) {
        var result = -1, res = false;
        if (typeof mode == 'string' && this.playModeSupport.length) {
          result = this.find(mode, this.playModeSupport);
        }
        if (result >= 0) {
          this.currentPlayModeIdx = result;
          this.currentPlayMode = this.playModeSupport[result];
          res = true;
        }
        if (typeof callback == "function") {
          callback.call(callback, res);
        }
        return res;
      };

      Player.prototype.volumeUp = function() {
        if (this.volume + this.volumeStep <= this.maxVolume) {
          this.volume += this.volumeStep;
          this.setVolume({value: this.volume});
        }
      };

      Player.prototype.volumeDown = function() {
        if (this.volume - this.volumeStep >= 0) {
          this.volume -= this.volumeStep;
          this.setVolume({value: this.volume});
          // 判断当前音量是否为0
        }
      };

      return Player;
    })();
    PlayerModule.Player = Player;

  })((PlayerModule = evm.PlayerModule || (evm.PlayerModule = {})));
})(evm || (evm = {}));