/*
 * 中间件及PC端播放器
 */

//==============================================================================
if(typeof evm === "undefined") {
     throw Error("Pls import evm.js");
}
function util_mediaPlayer(_c/*config object*/) {
    this.platform = null;
    this.config = _c;
    this.media_width = _c.mediaWidth || 100;
    this.media_height = _c.mediaHeight || 75;
    this.media_x = _c.mediaX || 0;
    this.media_y = _c.mediaY || 0;
    this.callback = _c.callback || null;
    this.isFullscreen = evm.isBoolean(_c.isFullscreen)
                        ? _c.isFullscreen
                        : false
    this.getMediaType = function(_type) {
        var mediaType = "";
        if(evm.isUndefined(_type)) {
            return mediaType;
        }
        _type = evm.trim(_type).toLowerCase();
        
        switch(_type) {
            case "ngod":
            case "rtsp":
                mediaType = "VOD";
                break;
            case "c4cam_live":
            case "http":
            case "https":
                mediaType = "HTTP";
                break;
            case "delivery":
                mediaType = "DVB";
                break;
            case "file":
                mediaType = "FILE";
                break;
        }
        return mediaType;
    }
};

util_mediaPlayer.factory = function (_type/*string:middleware*/, _c/*config object*/) {
    var
        constr = _type
       ,newInstance = null;
    
    if(/chrome|firefox|ie|unknown/.test(_type)) {
        constr = 'pc';
    }
    
    if(evm.isUndefined(_c)) {
        throw Error('util_mediaPlayer.facory()没有传配置对象');
    }
  
    if(!evm.isFunction(util_mediaPlayer[constr])) {
        throw Error('util_mediaPlayer未定义' + constr + '构造方法');
    }
    
    newInstance = new util_mediaPlayer[constr](_c);
    return newInstance;
};


//========================PC Device=============================================
util_mediaPlayer.pc = function(_c/*config object*/) {
     util_mediaPlayer.call(this, _c);
     this.platform = "pc";
}
evm.extend(util_mediaPlayer.pc.prototype, {
    play: function () {
        return true;
    }
    ,pause: function () {
        return true;
    }
    ,stop: function () {
        return true;
    }
    ,resume: function() {
        return true;
    }
    ,setPosition: function(x,y,w,h) {
        return true;
    }
    ,setFullScreen: function() {
        return true;
    }
    ,getMute: function() {
        var isMute = 0;
        return isMute;
    }
    ,setMute: function(_b/*boolean*/) {
        return true;
    }
    ,mute: function() {
        return true;
    }
    ,unmute: function() {
        return true;
    }
    ,systemEvent: function(_cb) {
        return true;
    }
    ,setVolume: function(_v) {
        return false;
    }
    ,getVolume: function() {
        // range (0~31)
        return false;
    }
    ,getDuration: function() {
        var duration = 0;
        return duration;
    }
    ,getElapse: function() {
        var elapse = 0;
        return elapse;
    }
    ,seek: function(_second/*number*/) {
        return false;
    }
});
//========================enrich浏览器===========================================
util_mediaPlayer.enrich = function (_c/*config object*/) {
    util_mediaPlayer.call(this, _c);
    this.platform = "enrich";
};
evm.extend(util_mediaPlayer.enrich.prototype, {
    play: function (_u) {
        if(!_u) {
            return true;
        }
        try{
            return false;
        }catch(E) {}
        return true;
    }
    ,pause: function () {
        return true;
    }
    ,stop: function () {
        return true;
    }
    ,resume: function() {
        return true;
    }
    ,setPosition: function(x,y,w,h) {
        return true;
    }
    ,setFullScreen: function() {
        return true;
    }
    ,getMute: function() {
        var isMute = 0;
        return isMute;
    }
    ,setMute: function(_b/*boolean*/) {
        return true;
    }
    ,mute: function() {
        return true;
    }
    ,unmute: function() {
        return true;
    }
    ,systemEvent: function(_cb) {
        return true;
    }
    ,setVolume: function(_v) {
        return false;
    }
    ,getVolume: function() {
        // range (0~31)
        return false;
    }
    ,getDuration: function() {
        var duration = 0;
        return duration;
    }
    ,getElapse: function() {
        var elapse = 0;
        return elapse;
    }
    ,seek: function(_second/*number*/) {
        return false;
    }
});

//========================enrich_河北浏览器======================================
util_mediaPlayer.enrich_hebei = function (_c/*config object*/) {
    util_mediaPlayer.call(this, _c);
    this.platform = "enrich_hebei";
};

evm.extend(util_mediaPlayer.enrich_hebei.prototype, {
    play: function (_u) {
        if(!_u) {
            return false;
        }
        return true;
    }
    ,pause: function () {
        return true;
    }
    ,stop: function () {
        return true;
    }
    ,resume: function() {
        return true;
    }
    ,setPosition: function(x,y,w,h) {
        return true;
    }
    ,setFullScreen: function() {
        return true;
    }
    ,getMute: function() {
        var isMute = 0;
        return isMute;
    }
    ,setMute: function(_b/*boolean*/) {
        return true;
    }
    ,mute: function() {
        return true;
    }
    ,unmute: function() {
        return true;
    }
    ,systemEvent: function(_cb) {
        return true;
    }
    ,setVolume: function(_v) {
        return false;
    }
    ,getVolume: function() {
        // range (0~31)
        return false;
    }
    ,getDuration: function() {
        var duration = 0;
        return duration;
    }
    ,getElapse: function() {
        var elapse = 0;
        return elapse;
    }
    ,seek: function(_second/*number*/) {
        return false;
    }
});

//========================inspur================================================
util_mediaPlayer.inspur = function (_c/*config object*/) {
    util_mediaPlayer.call(this, _c);
    this.platform = "inspur";
};
evm.extend(util_mediaPlayer.inspur.prototype, {
    play: function (_u) {
        if(!_u) {
            return false;
        }
        try{
            iSTB.player.play(_u);
        }catch(E) {
            return false;
        }
        return true;
    }
    ,pause: function () {
        try{
            iSTB.player.pause();
        }catch(E) {
            return false;
        }
        return true;
    }
    ,stop: function () {
        try{
            iSTB.player.stop();
        }catch(E) {
            return false;
        }
        return true;
    }
    ,resume: function() {
        try{
            iSTB.player.resume();
        }catch(E) {
            return false;
        }
        return true;
    }
    ,setPosition: function(x,y,w,h) {
        //$WebApp.widget.tips.show(this.media_x+"="+this.media_y+"="+this.media_width+"="+this.media_height, 5000);
        try{
            iSTB.player.set_video_window(x||this.media_x, y||this.media_y, w||this.media_width, h||this.media_height);
        }catch(E) {
            return false;
        }
        return true;
    }
    ,setFullScreen: function() {
        try{
            iSTB.player.set_video_window(0, 0, 1280, 720);
        }catch(E) {
            return false;
        }
        return true;
    }
    ,getMute: function() {
        var isMute = 0;
        try{
            isMute = iSTB.progdata.getmutestatus();
        }catch(E) {
            return isMute;
        }
        return isMute;
    }
    ,setMute: function(_b/*boolean*/) {
        this[_b?"mute":"unmute"]();
        try{
            iSTB.progdata.setmutestatus(_b?1:0);
        }catch(E){
            return false;
        }
        return true;
    }
    ,mute: function() {
        try{
            iSTB.player.mute();
        }catch(E) {
            return false;
        }
        return true;
    }
    ,unmute: function() {
        try{
            iSTB.player.unmute();
        }catch(E) {
            return false;
        }
        return true;
    }
    ,systemEvent: function(_cb/*string*/) {
        try{
            iSTB.evt.set_event_callback(_cb);
        }catch(E) {
            return false;
        }
        return true;
    }
    ,setVolume: function(_v) {
        try{
            iSTB.player.set_volume(_v);
        }catch(E) {
            return false;
        }
        return true;
    }
    ,getVolume: function() {
        // range (0~31)
        var vol = 0;
        try{
            vol = iSTB.player.get_volume();
        }catch(E) {
            return false;
        }
        return vol;
    }
    ,getDuration: function() {
        var duration = 0;
        try{
            duration = iSTB.player.get_duration();
        }catch(E) {
            return false;
        }
        return duration;
    }
    ,getElapse: function() {
        var elapse = 0;
        try{
            elapse = iSTB.player.get_position();
        }catch(E) {
            return false;
        }
        return elapse;
    }
    ,seek: function(_second/*number*/) {
        try{
            iSTB.player.seek(_second);
        }catch(E) {
            return false;
        }
        return true;
    }
});

//========================iPanel================================================
util_mediaPlayer.ipanel = function (_c/*config object*/) {
    util_mediaPlayer.call(this, _c);
    this.platform = "ipanel";
};

evm.extend(util_mediaPlayer.ipanel.prototype, {
    play: function (_u) {
        if(!_u) {
            return false;
        }
        return true;
    }
    ,pause: function () {
        return true;
    }
    ,stop: function () {
        return true;
    }
    ,resume: function() {
        return true;
    }
    ,setPosition: function(x,y,w,h) {
        return true;
    }
    ,setFullScreen: function() {
        return true;
    }
    ,getMute: function() {
        var isMute = 0;
        return isMute;
    }
    ,setMute: function(_b/*boolean*/) {
        return true;
    }
    ,mute: function() {
        return true;
    }
    ,unmute: function() {
        return true;
    }
    ,systemEvent: function(_cb) {
        return true;
    }
    ,setVolume: function(_v) {
        return false;
    }
    ,getVolume: function() {
        // range (0~31)
        return false;
    }
    ,getDuration: function() {
        var duration = 0;
        return duration;
    }
    ,getElapse: function() {
        var elapse = 0;
        return elapse;
    }
    ,seek: function(_second/*number*/) {
        return false;
    }
});

//========================enrich_android (Hubei)================================================
util_mediaPlayer.enrich_android = function (_c/*config object*/) {
    util_mediaPlayer.call(this, _c);
    this.platform = "ipanel";
};

evm.extend(util_mediaPlayer.enrich_android.prototype, {
    play: function (_u) {
        if(!_u) {
            return false;
        }
        
        try{
            media.play(_u, this.media_x, this.media_y, this.media_width, this.media_height);
        }catch(E) {
            return false;
        }
        return true;
    }
    ,pause: function () {
        return true;
    }
    ,stop: function () {
        try{
            media.stop();
        }catch(E) {
            return false;
        }
        return true;
    }
    ,resume: function() {
        return true;
    }
    ,setPosition: function(x,y,w,h) {
        return true;
    }
    ,setFullScreen: function() {
        return true;
    }
    ,getMute: function() {
        var isMute = 0;
        return isMute;
    }
    ,setMute: function(_b/*boolean*/) {
        return true;
    }
    ,mute: function() {
        return true;
    }
    ,unmute: function() {
        return true;
    }
    ,systemEvent: function(_cb) {
        return true;
    }
    ,setVolume: function(_v) {
        return false;
    }
    ,getVolume: function() {
        // range (0~31)
        return false;
    }
    ,getDuration: function() {
        var duration = 0;
        return duration;
    }
    ,getElapse: function() {
        var elapse = 0;
        return elapse;
    }
    ,seek: function(_second/*number*/) {
        return false;
    }
});

