/**
 * @file 弹出框组件
 * @imports /swatapps/ape/evm.js /swatapps/ape/widget-v1/base.js
 */

function Popup(options){
    //弹出框元素
    this.element;
    //遮罩层
    this.overlay;
    //内容的html模板
    this.template = '<img /><span style="display:block;font-size:22px;padding:10px 0;">{text}</span>';

    //配置接口方法
    this.onWidgetBlur = options.onWidgetBlur || function(){};
}
extend(Popup,KeyListenBase);
evm.extend(Popup.prototype,{
    _status:'',
    //背景图片
    bg:'../../widget-v1/popup/skin/a/img/bg.jpg',
    //提示状态的icons
    icons:{
        success:'../../widget-v1/popup/skin/a/img/success.png',
        failure:'',
        waiting:'',
        warn:''
    },
    action:function(alias){
        switch(alias){
            case 'SELECT':
                this.hide();
                this.onWidgetBlur(alias);
                break;
        }
    },
    init:function(){
        //创建DOM
        this.element = document.createElement('DIV');
        this.element.className = 'popup';
        this.element.style.display = 'none';
        this.element.style.position = 'relative';
        this.element.style.zIndex = '1000';
        this.element.style.width = '30%';
        this.element.style.textAlign = 'center';
        this.element.style.background = 'url('+ this.bg +') no-repeat left top';
        this.element.style.paddingTop = '10px';
        document.body.appendChild(this.element);

        this.overlay = document.createElement('DIV');
        this.overlay.className = 'popup-overlay';
        this.overlay.style.display = 'none';
        this.overlay.style.position = 'relative';
        this.overlay.style.zIndex = '999';
        this.overlay.style.backgroundColor = '#000';
        this.overlay.style.opacity = 0.5;
        this.overlay.style.width = '1280px';
        this.overlay.style.height = '720px';

        document.body.appendChild(this.overlay);
    },
    //@timeout 自动定时关闭弹出框，单位ms
    write:function(status,text,timeout){
        var me = this;
        this._status = status;

        var icon = this.icons[status];
        var tpl = this.template;
        var obj = {
            icon:icon,
            text:text
        };
        for(var prop in obj){
            tpl = tpl.replace(new RegExp('\\{'+prop+'\\}'),obj[prop]);
        }

        if(!this.element){
            this.init();
        }

        evm.removeChildren(this.element);
        this.element.innerHTML = tpl;

        this.show();

        if(timeout){
            window.setTimeout(function (){
                me.hide();
            },timeout);
        }
    },
    show:function() {
        var me = this;
        this.element.style.display = 'block';
        this.overlay.style.display = 'block';

        var imgElm = this.element.getElementsByTagName('img');
        if(imgElm.length){
            imgElm = imgElm[0];
            evm.addEvent(imgElm,'load',function(){
                me.center();
            });
            imgElm.src = this.icons[this._status];
        }
    },
    hide:function(){
        this.element.style.display = 'none';
        this.overlay.style.display = 'none';
    },
    center:function(){
        var w = parseFloat(this.element.offsetWidth),
            h = parseFloat(this.element.offsetHeight);

        this.element.style.left = (1280-w)/2+'px';
        this.element.style.top = (720-h)/2+'px';
    }
});