/**
 * @file 一个倒计时组件
 * @import /swatapps/ape/evm.js
 * @des 组件接口参考杨涛云组件定义规范
 */

(function(){
    evm.ext.comp.Countdown = function(options){
        //强制使用new
        if(this === evm.ext.comp || this === window){
            return new arguments.callee(options);
        }
        //必须传参
        if(evm.isUndefined(options) && !(evm.isObject(options))){
            throw new Error('evm.ext.comp.Countdown：没有传入参数');
        }
        function handler(options){
            // 触发事件的默认方法
            try{
                //console.log('VListBox 事件触发,默认处理方法');
            }catch(E){}
        }

        evm.ext.comp.BaseComponent.call(this,options);

        //====配置属性定义;=========================
        this.config = options;
        //倒计时完毕标志
        this._finishedFlag = false;
        //倒计时时间 单位ms
        this._timeout = +this.config.timeout || 1000;
        this._timeId;

        //====自定义事件的回调方法,在创建对象时传入对应的回调方法;=========================
        this.onBlur = this.config.onBlur || handler;
        this.onChange = this.config.onChange || handler;
        this.onChangeOut = this.config.onChangeOut || handler;
        this.onFocus = this.config.onFocus || handler;
        this.onFilter = this.config.onFilter || handler;
        this.onSelect = this.config.onSelect || handler;
        this.onEvent  = this.config.onEvent || handler;
    };
    evm.extend(evm.ext.comp.Countdown.prototype,{
        init:function(){
            var me = this;
            if(this._timeout){
                this._timeId = window.setInterval(function(){
                    me._run();
                },1000);
            }
            me._run();
        },
        //方法判定计时完毕
        getFinishedFlag:function(){
            return this._finishedFlag;
        },
        _run:function(){
            var evt = {
                type:'countdown',
                time:Math.ceil(this._timeout/1000),
                finished:this._finishedFlag
            }
            this.onEvent(evt);
            if(this._timeout <= 0){
                window.clearInterval(this._timeId);
                this._finishedFlag = true;
            }

            this._timeout -= 1000;
        }
    });
})();